Skip to main content
POST
/
v1
/
chat
/
completions
Create Chat Completion
curl --request POST \
  --url https://api.example.com/v1/chat/completions \
  --header 'Content-Type: application/json' \
  --data '
{
  "messages": [
    {
      "content": "<string>",
      "role": "developer",
      "name": "<string>"
    }
  ],
  "model": "<string>",
  "audio": {
    "format": "<string>",
    "voice": "<string>"
  },
  "frequency_penalty": 123,
  "logit_bias": {},
  "logprobs": true,
  "max_completion_tokens": 1,
  "metadata": {},
  "modalities": [
    "<string>"
  ],
  "n": 1,
  "parallel_tool_calls": true,
  "prediction": {
    "content": "<string>",
    "type": "<string>"
  },
  "presence_penalty": 123,
  "prompt_cache_key": "<string>",
  "reasoning_effort": "<string>",
  "response_format": "<unknown>",
  "seed": 123,
  "service_tier": "<string>",
  "stop": [
    "<string>"
  ],
  "store": true,
  "stream": true,
  "stream_options": {
    "include_usage": true
  },
  "temperature": 123,
  "tool_choice": "<unknown>",
  "tools": [
    {
      "function": {
        "name": "<string>",
        "description": "<string>",
        "parameters": "<unknown>",
        "strict": true
      },
      "type": "<string>"
    }
  ],
  "top_logprobs": 1,
  "top_p": 123,
  "user": "<string>"
}
'
{
  "choices": [
    {
      "finish_reason": "<string>",
      "index": 1,
      "message": {
        "role": "<string>",
        "annotations": "<unknown>",
        "audio": "<unknown>",
        "content": "<string>",
        "refusal": "<string>",
        "tool_calls": [
          {
            "function": {
              "arguments": "<string>",
              "name": "<string>"
            },
            "id": "<string>",
            "type": "<string>"
          }
        ]
      },
      "logprobs": "<unknown>"
    }
  ],
  "created": 1,
  "id": "<string>",
  "model": "<string>",
  "object": "<string>",
  "usage": {
    "completion_tokens": 1,
    "prompt_tokens": 1,
    "total_tokens": 1,
    "completion_tokens_details": "<unknown>",
    "prompt_tokens_details": "<unknown>"
  },
  "service_tier": "<string>",
  "system_fingerprint": "<string>"
}

Body

application/json
messages
object[]
required

A list of messages comprising the conversation so far.

A message in a chat completion request or response.

model
string
required

ID of the model to use.

audio
object

Parameters for audio output. Required when audio output is requested with modalities: ["audio"]. Input audio is automatically detected.

frequency_penalty
number<float> | null

Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.

logit_bias
object

Modify the likelihood of specified tokens appearing in the completion. Accepts a json object that maps tokens (specified by their token ID in the tokenizer) to an associated bias value from -100 to 100.

logprobs
boolean | null

Whether to return log probabilities of the output tokens or not. If true, returns the log probabilities of each output token returned in the content of message.

max_completion_tokens
integer<int32> | null

The maximum number of tokens that can be generated in the chat completion. The total length of input tokens and generated tokens is limited by the model's context length.

Required range: x >= 0
metadata
object

Developer-defined tags and values used for filtering completions in the dashboard.

modalities
string[] | null

Output types that you would like the model to generate for this request. Most models are capable of generating text, which is the default. The gpt-4o-audio-preview model can also be used to generate audio.

n
integer<int32> | null

How many chat completion choices to generate for each input message. Note that you will be charged based on the number of generated tokens across all of the choices. Keep n as 1 to minimize costs.

Required range: x >= 0
parallel_tool_calls
boolean | null

Whether to enable parallel function calling during tool use.

prediction
object

Configuration for a Predicted Output, which can greatly improve response times when large parts of the model response are known ahead of time. This is most common when you are regenerating a file with only minor changes to most of the content.

presence_penalty
number<float> | null

Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.

prompt_cache_key
string | null

Developer-supplied key for grouping related requests, used to mitigate model latency and performance issues for high-traffic applications. This key will be used on best effort basis to route requests to models that have seen the same prompt_cache_key values recently.

reasoning_effort
string | null

Constrains effort on reasoning for reasoning models. Currently supported values are low, medium, and high. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response.

response_format
any

An object specifying the format that the model must output. Compatible with GPT-4 Turbo and all GPT-3.5 Turbo models newer than gpt-3.5-turbo-1106. Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema.

seed
integer<int64> | null

This feature is in Beta. If specified, our system will make a best effort to sample deterministically, such that repeated requests with the same seed and parameters should return the same result. Determinism is not guaranteed.

service_tier
string | null

Specifies the latency tier to use for processing the request. This parameter is relevant for customers subscribed to the scale tier service. If set to 'auto', the system will utilize scale tier credits until they are exhausted. If set to 'default', the request will be processed using the default service tier with a lower uptime SLA and no latency guarantee.

stop
string[] | null

Up to 4 sequences where the API will stop generating further tokens.

store
boolean | null

Whether or not to store the output of this chat completion request for use in our model distillation or evals products.

stream
boolean | null

If set, partial message deltas will be sent. Tokens will be sent as data-only server-sent events as they become available, with the stream terminated by a data: [DONE] message.

stream_options
object

Options for streaming response. Only set this when you set stream: true.

temperature
number<float> | null

What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.

tool_choice
any

Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools. Specifying a particular tool via {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.

tools
object[] | null

A list of tools the model may call. Currently, only functions are supported as a tool. Use this to provide a list of functions the model may generate JSON inputs for.

top_logprobs
integer<int32> | null

An integer between 0 and 20 specifying the number of most likely tokens to return at each token position, each with an associated log probability. logprobs must be set to true if this parameter is used.

Required range: x >= 0
top_p
number<float> | null

An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.

user
string | null

A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse.

Response

Chat completion created successfully

Represents a chat completion response returned by model, based on the provided input.

choices
object[]
required

A list of chat completion choices. Can be more than one if n is greater than 1.

created
integer<int64>
required

The Unix timestamp (in seconds) of when the chat completion was created.

Required range: x >= 0
id
string
required

A unique identifier for the chat completion.

model
string
required

The model used for the chat completion.

object
string
required

The object type, which is always chat.completion.

usage
object
required

Usage statistics for the completion request.

service_tier
string | null

The service tier used for processing the request. This field is only included if the service_tier parameter is specified in the request.

system_fingerprint
string | null

This fingerprint represents the backend configuration that the model runs with. Can be used in conjunction with the seed request parameter to understand when backend changes have been made that might impact determinism.